'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = wrapRoute;

var _reactRedux = require('react-redux');

var _reduxFeatures = require('redux-features');

var _reselect = require('reselect');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var babelPluginFlowReactPropTypes_proptype_RouteComponent = require('react-router').babelPluginFlowReactPropTypes_proptype_RouteComponent || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_RouterState = require('react-router').babelPluginFlowReactPropTypes_proptype_RouterState || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_PlainRoute = require('react-router').babelPluginFlowReactPropTypes_proptype_PlainRoute || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_FeatureState = require('redux-features').babelPluginFlowReactPropTypes_proptype_FeatureState || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_Options = require('./wrapRoute').babelPluginFlowReactPropTypes_proptype_Options || require('prop-types').any;

function wrapRoute(options) {
  var store = options.store,
      featureId = options.featureId,
      featureName = options.featureName,
      getFeatureStates = options.getFeatureStates,
      rematchRoutes = options.rematchRoutes,
      isServer = options.isServer;

  var route = typeof options.route === 'function' ? options.route(store) : options.route;
  var result = (0, _extends3.default)({}, route);

  var selectFeatureState = (0, _reselect.createSelector)(getFeatureStates, function (featureStates) {
    return featureStates[featureId];
  });

  var FeatureStateAlert = options.FeatureStateAlert && (0, _reactRedux.connect)((0, _reselect.createSelector)(selectFeatureState, function (featureState) {
    return { featureId: featureId, featureName: featureName, featureState: featureState };
  }))(options.FeatureStateAlert);

  delete result.component;

  result.getComponent = function (nextState, callback) {
    var featureState = selectFeatureState(store.getState());

    if (featureState !== 'LOADED') {
      callback(null, FeatureStateAlert);
    } else if (route.getComponent) {
      route.getComponent(nextState, callback);
    } else if (route.component) {
      callback(null, route.component);
    } else {
      callback(null, null);
    }
  };

  result.onEnter = function (nextState, replace, callback) {
    var promise = _promise2.default.resolve();
    if (selectFeatureState(store.getState()) === 'NOT_LOADED') {
      promise = store.dispatch((0, _reduxFeatures.loadFeature)(featureId));
      if (rematchRoutes) promise.then(function () {
        return rematchRoutes(store);
      });
    }
    var waitOnServerOnly = isServer ? promise : _promise2.default.resolve();
    waitOnServerOnly.then(function () {
      return route.onEnter ? route.onEnter(nextState, replace, callback) : callback(null);
    }).catch(function (error) {
      return callback(error);
    });
  };

  return result;
}